/* WindowSwitcher.c generated by valac 0.56.17, the Vala compiler
 * generated from WindowSwitcher.vala, do not modify */

/*
 * Copyright 2021 Aral Balkan <mail@ar.al>
 * Copyright 2020 Mark Story <mark@mark-story.com>
 * Copyright 2017 Popye <sailor3101@gmail.com>
 * Copyright 2014 Tom Beckmann
 * Copyright 2023 elementary, Inc. <https://elementary.io>
 * SPDX-License-Identifier: GPL-3.0-or-later
 */

#include "gala.h"
#include <glib-object.h>
#include <glib.h>
#include <clutter/clutter.h>
#include <float.h>
#include <math.h>
#include <cairo-gobject.h>
#include <stdlib.h>
#include <string.h>
#include <meta/meta-plugin.h>
#include <meta/display.h>
#include <mtk/mtk.h>
#include <gdk/gdk.h>
#include <meta/window.h>
#include <meta/keybindings.h>
#include <meta/workspace.h>
#include <meta/meta-workspace-manager.h>
#include <atk/atk.h>
#include <meta/prefs.h>
#include <meta/meta-cursor-tracker.h>
#include <glib/gi18n-lib.h>
#include <pango/pango.h>
#include <meta/meta-monitor-manager.h>
#include <meta/meta-context.h>
#include <meta/meta-backend.h>

#define GALA_WINDOW_SWITCHER_ICON_SIZE 64
#define GALA_WINDOW_SWITCHER_WRAPPER_PADDING 12
#define GALA_WINDOW_SWITCHER_CAPTION_FONT_NAME "Inter"
#define GALA_WINDOW_SWITCHER_MIN_OFFSET 64
#define GALA_WINDOW_SWITCHER_ANIMATION_DURATION 200
#define GALA_WINDOW_SWITCHER_GESTURE_RANGE_LIMIT 10
#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif
#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

#define GALA_TYPE_WINDOW_SWITCHER (gala_window_switcher_get_type ())
#define GALA_WINDOW_SWITCHER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GALA_TYPE_WINDOW_SWITCHER, GalaWindowSwitcher))
#define GALA_WINDOW_SWITCHER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GALA_TYPE_WINDOW_SWITCHER, GalaWindowSwitcherClass))
#define GALA_IS_WINDOW_SWITCHER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GALA_TYPE_WINDOW_SWITCHER))
#define GALA_IS_WINDOW_SWITCHER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GALA_TYPE_WINDOW_SWITCHER))
#define GALA_WINDOW_SWITCHER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GALA_TYPE_WINDOW_SWITCHER, GalaWindowSwitcherClass))

typedef struct _GalaWindowSwitcher GalaWindowSwitcher;
typedef struct _GalaWindowSwitcherClass GalaWindowSwitcherClass;
typedef struct _GalaWindowSwitcherPrivate GalaWindowSwitcherPrivate;

#define GALA_TYPE_GESTURE_TRACKER (gala_gesture_tracker_get_type ())
#define GALA_GESTURE_TRACKER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GALA_TYPE_GESTURE_TRACKER, GalaGestureTracker))
#define GALA_GESTURE_TRACKER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GALA_TYPE_GESTURE_TRACKER, GalaGestureTrackerClass))
#define GALA_IS_GESTURE_TRACKER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GALA_TYPE_GESTURE_TRACKER))
#define GALA_IS_GESTURE_TRACKER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GALA_TYPE_GESTURE_TRACKER))
#define GALA_GESTURE_TRACKER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GALA_TYPE_GESTURE_TRACKER, GalaGestureTrackerClass))

typedef struct _GalaGestureTracker GalaGestureTracker;
typedef struct _GalaGestureTrackerClass GalaGestureTrackerClass;

#define GALA_TYPE_WINDOW_SWITCHER_ICON (gala_window_switcher_icon_get_type ())
#define GALA_WINDOW_SWITCHER_ICON(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GALA_TYPE_WINDOW_SWITCHER_ICON, GalaWindowSwitcherIcon))
#define GALA_WINDOW_SWITCHER_ICON_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GALA_TYPE_WINDOW_SWITCHER_ICON, GalaWindowSwitcherIconClass))
#define GALA_IS_WINDOW_SWITCHER_ICON(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GALA_TYPE_WINDOW_SWITCHER_ICON))
#define GALA_IS_WINDOW_SWITCHER_ICON_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GALA_TYPE_WINDOW_SWITCHER_ICON))
#define GALA_WINDOW_SWITCHER_ICON_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GALA_TYPE_WINDOW_SWITCHER_ICON, GalaWindowSwitcherIconClass))

typedef struct _GalaWindowSwitcherIcon GalaWindowSwitcherIcon;
typedef struct _GalaWindowSwitcherIconClass GalaWindowSwitcherIconClass;
enum  {
	GALA_WINDOW_SWITCHER_0_PROPERTY,
	GALA_WINDOW_SWITCHER_WM_PROPERTY,
	GALA_WINDOW_SWITCHER_GESTURE_TRACKER_PROPERTY,
	GALA_WINDOW_SWITCHER_OPENED_PROPERTY,
	GALA_WINDOW_SWITCHER_NUM_PROPERTIES
};
static GParamSpec* gala_window_switcher_properties[GALA_WINDOW_SWITCHER_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define __vala_ClutterColor_free0(var) ((var == NULL) ? NULL : (var = (_vala_ClutterColor_free (var), NULL)))
typedef enum  {
	GALA_GESTURE_DIRECTION_UNKNOWN = 0,
	GALA_GESTURE_DIRECTION_UP = 1,
	GALA_GESTURE_DIRECTION_DOWN = 2,
	GALA_GESTURE_DIRECTION_LEFT = 3,
	GALA_GESTURE_DIRECTION_RIGHT = 4,
	GALA_GESTURE_DIRECTION_IN = 5,
	GALA_GESTURE_DIRECTION_OUT = 6
} GalaGestureDirection;

#define GALA_TYPE_GESTURE_DIRECTION (gala_gesture_direction_get_type ())
typedef struct _Block77Data Block77Data;
typedef void (*GalaGestureTrackerOnUpdate) (gdouble percentage, gpointer user_data);
typedef void (*GalaGestureTrackerOnEnd) (gdouble percentage, gint completions, gint calculated_duration, gpointer user_data);
typedef void (*GalaGestureTrackerOnBegin) (gdouble percentage, gpointer user_data);

#define GALA_TYPE_WINDOW_TRACKER (gala_window_tracker_get_type ())
#define GALA_WINDOW_TRACKER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GALA_TYPE_WINDOW_TRACKER, GalaWindowTracker))
#define GALA_WINDOW_TRACKER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GALA_TYPE_WINDOW_TRACKER, GalaWindowTrackerClass))
#define GALA_IS_WINDOW_TRACKER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GALA_TYPE_WINDOW_TRACKER))
#define GALA_IS_WINDOW_TRACKER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GALA_TYPE_WINDOW_TRACKER))
#define GALA_WINDOW_TRACKER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GALA_TYPE_WINDOW_TRACKER, GalaWindowTrackerClass))

typedef struct _GalaWindowTracker GalaWindowTracker;
typedef struct _GalaWindowTrackerClass GalaWindowTrackerClass;

#define GALA_TYPE_WINDOW_MANAGER_GALA (gala_window_manager_gala_get_type ())
#define GALA_WINDOW_MANAGER_GALA(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GALA_TYPE_WINDOW_MANAGER_GALA, GalaWindowManagerGala))
#define GALA_WINDOW_MANAGER_GALA_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GALA_TYPE_WINDOW_MANAGER_GALA, GalaWindowManagerGalaClass))
#define GALA_IS_WINDOW_MANAGER_GALA(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GALA_TYPE_WINDOW_MANAGER_GALA))
#define GALA_IS_WINDOW_MANAGER_GALA_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GALA_TYPE_WINDOW_MANAGER_GALA))
#define GALA_WINDOW_MANAGER_GALA_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GALA_TYPE_WINDOW_MANAGER_GALA, GalaWindowManagerGalaClass))

typedef struct _GalaWindowManagerGala GalaWindowManagerGala;
typedef struct _GalaWindowManagerGalaClass GalaWindowManagerGalaClass;

struct _GalaWindowSwitcher {
	GalaCanvasActor parent_instance;
	GalaWindowSwitcherPrivate * priv;
};

struct _GalaWindowSwitcherClass {
	GalaCanvasActorClass parent_class;
};

struct _GalaWindowSwitcherPrivate {
	GalaWindowManager* _wm;
	GalaGestureTracker* _gesture_tracker;
	gboolean _opened;
	gboolean handling_gesture;
	gint modifier_mask;
	GalaModalProxy* modal_proxy;
	GalaDrawingStyleManager* style_manager;
	ClutterActor* container;
	ClutterText* caption;
	GalaShadowEffect* shadow_effect;
	GalaWindowSwitcherIcon* _current_icon;
	gfloat scaling_factor;
};

struct _Block77Data {
	int _ref_count_;
	GalaWindowSwitcher* self;
	gint last_window_index;
	GalaGestureDirection direction;
};

static gint GalaWindowSwitcher_private_offset;
static gpointer gala_window_switcher_parent_class = NULL;

VALA_EXTERN GType gala_window_switcher_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (GalaWindowSwitcher, g_object_unref)
VALA_EXTERN GType gala_gesture_tracker_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (GalaGestureTracker, g_object_unref)
VALA_EXTERN GType gala_window_switcher_icon_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (GalaWindowSwitcherIcon, g_object_unref)
VALA_EXTERN GalaWindowSwitcher* gala_window_switcher_new (GalaWindowManager* wm,
                                              GalaGestureTracker* gesture_tracker);
VALA_EXTERN GalaWindowSwitcher* gala_window_switcher_construct (GType object_type,
                                                    GalaWindowManager* wm,
                                                    GalaGestureTracker* gesture_tracker);
static void gala_window_switcher_scale (GalaWindowSwitcher* self);
VALA_EXTERN GalaWindowManager* gala_window_switcher_get_wm (GalaWindowSwitcher* self);
VALA_EXTERN gint gala_internal_utils_scale_to_int (gint value,
                                       gfloat scale_factor);
static void gala_window_switcher_real_get_preferred_width (ClutterActor* base,
                                                    gfloat for_height,
                                                    gfloat* min_width,
                                                    gfloat* natural_width);
static void gala_window_switcher_real_draw (GalaCanvasActor* base,
                                     cairo_t* ctx,
                                     gint width,
                                     gint height);
static void _vala_ClutterColor_free (ClutterColor* self);
VALA_EXTERN void gala_window_switcher_handle_switch_windows (MetaDisplay* display,
                                                 MetaWindow* window,
                                                 ClutterKeyEvent* event,
                                                 MetaKeyBinding* binding,
                                                 GalaWindowSwitcher* self);
VALA_EXTERN gboolean gala_window_switcher_get_opened (GalaWindowSwitcher* self);
static gboolean gala_window_switcher_collect_current_windows (GalaWindowSwitcher* self,
                                                       MetaDisplay* display,
                                                       MetaWorkspace* workspace);
static gboolean gala_window_switcher_collect_all_windows (GalaWindowSwitcher* self,
                                                   MetaDisplay* display,
                                                   MetaWorkspace* workspace);
static void gala_window_switcher_open_switcher (GalaWindowSwitcher* self);
static void gala_window_switcher_next_window (GalaWindowSwitcher* self,
                                       gboolean backward);
VALA_EXTERN GType gala_gesture_direction_get_type (void) G_GNUC_CONST ;
VALA_EXTERN void gala_window_switcher_handle_gesture (GalaWindowSwitcher* self,
                                          GalaGestureDirection direction);
static Block77Data* block77_data_ref (Block77Data* _data77_);
static void block77_data_unref (void * _userdata_);
static void __lambda81_ (Block77Data* _data77_,
                  gdouble percentage);
VALA_EXTERN gfloat gala_gesture_tracker_animation_value (gfloat initial_value,
                                             gfloat target_value,
                                             gdouble percentage,
                                             gboolean rounded);
static void ___lambda81__gala_gesture_tracker_on_update (gdouble percentage,
                                                  gpointer self);
static void __lambda82_ (GalaWindowSwitcher* self,
                  gdouble percentage,
                  gint cancel_action,
                  gint calculated_duration);
static void gala_window_switcher_close_switcher (GalaWindowSwitcher* self,
                                          guint32 time,
                                          gboolean cancel);
static void ___lambda82__gala_gesture_tracker_on_end (gdouble percentage,
                                               gint completions,
                                               gint calculated_duration,
                                               gpointer self);
VALA_EXTERN GalaGestureTracker* gala_window_switcher_get_gesture_tracker (GalaWindowSwitcher* self);
VALA_EXTERN void gala_gesture_tracker_connect_handlers (GalaGestureTracker* self,
                                            GalaGestureTrackerOnBegin on_begin_handler,
                                            gpointer on_begin_handler_target,
                                            GDestroyNotify on_begin_handler_target_destroy_notify,
                                            GalaGestureTrackerOnUpdate on_update_handler,
                                            gpointer on_update_handler_target,
                                            GDestroyNotify on_update_handler_target_destroy_notify,
                                            GalaGestureTrackerOnEnd on_end_handler,
                                            gpointer on_end_handler_target,
                                            GDestroyNotify on_end_handler_target_destroy_notify);
static void gala_window_switcher_set_current_icon (GalaWindowSwitcher* self,
                                            GalaWindowSwitcherIcon* value);
VALA_EXTERN GalaWindowSwitcherIcon* gala_window_switcher_icon_new (MetaWindow* window,
                                                       gint icon_size,
                                                       gfloat scale_factor);
VALA_EXTERN GalaWindowSwitcherIcon* gala_window_switcher_icon_construct (GType object_type,
                                                             MetaWindow* window,
                                                             gint icon_size,
                                                             gfloat scale_factor);
static void gala_window_switcher_add_icon (GalaWindowSwitcher* self,
                                    GalaWindowSwitcherIcon* icon);
VALA_EXTERN GType gala_window_tracker_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (GalaWindowTracker, g_object_unref)
VALA_EXTERN GType gala_window_manager_gala_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (GalaWindowManagerGala, g_object_unref)
VALA_EXTERN GalaWindowTracker* gala_window_manager_gala_get_window_tracker (GalaWindowManagerGala* self);
VALA_EXTERN GalaApp* gala_window_tracker_get_app_for_window (GalaWindowTracker* self,
                                                 MetaWindow* window);
static gboolean __lambda79_ (GalaWindowSwitcher* self,
                      ClutterActor* _icon,
                      ClutterEvent* event);
static GalaWindowSwitcherIcon* gala_window_switcher_get_current_icon (GalaWindowSwitcher* self);
static gboolean ___lambda79__clutter_actor_motion_event (ClutterActor* _sender,
                                                  ClutterEvent* event,
                                                  gpointer self);
static void gala_window_switcher_toggle_display (GalaWindowSwitcher* self,
                                          gboolean show);
static void gala_window_switcher_set_opened (GalaWindowSwitcher* self,
                                      gboolean value);
static void gala_window_switcher_push_modal (GalaWindowSwitcher* self);
static gboolean __lambda80_ (GalaWindowSwitcher* self,
                      MetaKeyBinding* binding);
static gboolean ___lambda80__gala_keybinding_filter (MetaKeyBinding* binding,
                                              gpointer self);
VALA_EXTERN MetaWindow* gala_window_switcher_icon_get_window (GalaWindowSwitcherIcon* self);
static void gala_window_switcher_update_caption_text (GalaWindowSwitcher* self);
static void gala_window_switcher_real_key_focus_out (ClutterActor* base);
static gboolean gala_window_switcher_container_mouse_release (GalaWindowSwitcher* self,
                                                       ClutterEvent* event);
static gboolean gala_window_switcher_real_key_release_event (ClutterActor* base,
                                                      ClutterEvent* event);
static inline ClutterModifierType gala_window_switcher_get_current_modifiers (GalaWindowSwitcher* self);
static gboolean gala_window_switcher_real_key_press_event (ClutterActor* base,
                                                    ClutterEvent* event);
static void gala_window_switcher_set_wm (GalaWindowSwitcher* self,
                                  GalaWindowManager* value);
static void gala_window_switcher_set_gesture_tracker (GalaWindowSwitcher* self,
                                               GalaGestureTracker* value);
VALA_EXTERN void gala_window_switcher_icon_set_selected (GalaWindowSwitcherIcon* self,
                                             gboolean value);
static GObject * gala_window_switcher_constructor (GType type,
                                            guint n_construct_properties,
                                            GObjectConstructParam * construct_properties);
static gboolean _gala_window_switcher_container_mouse_release_clutter_actor_button_release_event (ClutterActor* _sender,
                                                                                           ClutterEvent* event,
                                                                                           gpointer self);
static void _clutter_content_invalidate_g_object_notify (GObject* _sender,
                                                  GParamSpec* pspec,
                                                  gpointer self);
static void _gala_window_switcher_scale_meta_monitor_manager_monitors_changed (MetaMonitorManager* _sender,
                                                                        gpointer self);
static void _gala_window_switcher___lambda83_ (GalaWindowSwitcher* self);
static void __gala_window_switcher___lambda83__g_object_notify (GObject* _sender,
                                                         GParamSpec* pspec,
                                                         gpointer self);
static void gala_window_switcher_finalize (GObject * obj);
static GType gala_window_switcher_get_type_once (void);
static void _vala_gala_window_switcher_get_property (GObject * object,
                                              guint property_id,
                                              GValue * value,
                                              GParamSpec * pspec);
static void _vala_gala_window_switcher_set_property (GObject * object,
                                              guint property_id,
                                              const GValue * value,
                                              GParamSpec * pspec);

static inline gpointer
gala_window_switcher_get_instance_private (GalaWindowSwitcher* self)
{
	return G_STRUCT_MEMBER_P (self, GalaWindowSwitcher_private_offset);
}

GalaWindowSwitcher*
gala_window_switcher_construct (GType object_type,
                                GalaWindowManager* wm,
                                GalaGestureTracker* gesture_tracker)
{
	GalaWindowSwitcher * self = NULL;
#line 54 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	g_return_val_if_fail (wm != NULL, NULL);
#line 54 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	g_return_val_if_fail (gesture_tracker != NULL, NULL);
#line 55 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	self = (GalaWindowSwitcher*) g_object_new (object_type, "wm", wm, "gesture-tracker", gesture_tracker, NULL);
#line 54 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	return self;
#line 345 "WindowSwitcher.c"
}

GalaWindowSwitcher*
gala_window_switcher_new (GalaWindowManager* wm,
                          GalaGestureTracker* gesture_tracker)
{
#line 54 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	return gala_window_switcher_construct (GALA_TYPE_WINDOW_SWITCHER, wm, gesture_tracker);
#line 354 "WindowSwitcher.c"
}

static void
gala_window_switcher_scale (GalaWindowSwitcher* self)
{
	GalaWindowManager* _tmp0_;
	MetaDisplay* _tmp1_;
	GalaWindowManager* _tmp2_;
	MetaDisplay* _tmp3_;
	GalaShadowEffect* _tmp4_;
	gint margin = 0;
	ClutterActor* _tmp5_;
	ClutterActor* _tmp6_;
	ClutterActor* _tmp7_;
	ClutterActor* _tmp8_;
	ClutterText* _tmp9_;
	ClutterText* _tmp10_;
	ClutterText* _tmp11_;
#line 111 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	g_return_if_fail (self != NULL);
#line 112 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp0_ = self->priv->_wm;
#line 112 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp1_ = meta_plugin_get_display ((MetaPlugin*) _tmp0_);
#line 112 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp2_ = self->priv->_wm;
#line 112 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp3_ = meta_plugin_get_display ((MetaPlugin*) _tmp2_);
#line 112 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	self->priv->scaling_factor = meta_display_get_monitor_scale (_tmp1_, meta_display_get_current_monitor (_tmp3_));
#line 114 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp4_ = self->priv->shadow_effect;
#line 114 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	gala_shadow_effect_set_scale_factor (_tmp4_, self->priv->scaling_factor);
#line 116 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	margin = gala_internal_utils_scale_to_int (GALA_WINDOW_SWITCHER_WRAPPER_PADDING, self->priv->scaling_factor);
#line 118 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp5_ = self->priv->container;
#line 118 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	clutter_actor_set_margin_left (_tmp5_, (gfloat) margin);
#line 119 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp6_ = self->priv->container;
#line 119 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	clutter_actor_set_margin_right (_tmp6_, (gfloat) margin);
#line 120 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp7_ = self->priv->container;
#line 120 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	clutter_actor_set_margin_bottom (_tmp7_, (gfloat) margin);
#line 121 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp8_ = self->priv->container;
#line 121 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	clutter_actor_set_margin_top (_tmp8_, (gfloat) margin);
#line 123 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp9_ = self->priv->caption;
#line 123 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	clutter_actor_set_margin_left ((ClutterActor*) _tmp9_, (gfloat) margin);
#line 124 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp10_ = self->priv->caption;
#line 124 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	clutter_actor_set_margin_right ((ClutterActor*) _tmp10_, (gfloat) margin);
#line 125 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp11_ = self->priv->caption;
#line 125 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	clutter_actor_set_margin_bottom ((ClutterActor*) _tmp11_, (gfloat) margin);
#line 419 "WindowSwitcher.c"
}

static void
gala_window_switcher_real_get_preferred_width (ClutterActor* base,
                                               gfloat for_height,
                                               gfloat* min_width,
                                               gfloat* natural_width)
{
	GalaWindowSwitcher * self;
	gfloat _vala_min_width = 0.0F;
	gfloat _vala_natural_width = 0.0F;
	gfloat preferred_nat_width = 0.0F;
	gfloat _tmp0_ = 0.0F;
	MetaDisplay* display = NULL;
	GalaWindowManager* _tmp1_;
	MetaDisplay* _tmp2_;
	gint monitor = 0;
	MtkRectangle geom = {0};
	MtkRectangle _tmp3_ = {0};
	gfloat container_nat_width = 0.0F;
	ClutterActor* _tmp4_;
	gfloat _tmp5_ = 0.0F;
	gfloat max_width = 0.0F;
	MtkRectangle _tmp6_;
#line 128 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	self = (GalaWindowSwitcher*) base;
#line 129 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_vala_min_width = (gfloat) 0;
#line 132 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	CLUTTER_ACTOR_CLASS (gala_window_switcher_parent_class)->get_preferred_width ((ClutterActor*) G_TYPE_CHECK_INSTANCE_CAST (self, GALA_TYPE_CANVAS_ACTOR, GalaCanvasActor), for_height, NULL, &_tmp0_);
#line 132 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	preferred_nat_width = _tmp0_;
#line 134 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp1_ = self->priv->_wm;
#line 134 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp2_ = meta_plugin_get_display ((MetaPlugin*) _tmp1_);
#line 134 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	display = _tmp2_;
#line 135 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	monitor = meta_display_get_current_monitor (display);
#line 136 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	meta_display_get_monitor_geometry (display, monitor, &_tmp3_);
#line 136 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	geom = _tmp3_;
#line 139 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp4_ = self->priv->container;
#line 139 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	clutter_actor_get_preferred_size (_tmp4_, NULL, NULL, &_tmp5_, NULL);
#line 139 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	container_nat_width = _tmp5_;
#line 141 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp6_ = geom;
#line 141 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	max_width = MIN ((gfloat) (_tmp6_.width - (gala_internal_utils_scale_to_int (GALA_WINDOW_SWITCHER_MIN_OFFSET, self->priv->scaling_factor) * 2)), container_nat_width);
#line 146 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_vala_natural_width = MIN (max_width, preferred_nat_width);
#line 128 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	if (min_width) {
#line 128 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		*min_width = _vala_min_width;
#line 480 "WindowSwitcher.c"
	}
#line 128 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	if (natural_width) {
#line 128 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		*natural_width = _vala_natural_width;
#line 486 "WindowSwitcher.c"
	}
}

static ClutterColor*
_vala_clutter_color_from_string (const gchar* str)
{
	ClutterColor* color = NULL;
	ClutterColor* _tmp0_;
	ClutterColor* result;
#line 7561 "mutter-clutter-14.vapi"
	g_return_val_if_fail (str != NULL, NULL);
#line 7562 "mutter-clutter-14.vapi"
	_tmp0_ = clutter_color_alloc ();
#line 7562 "mutter-clutter-14.vapi"
	color = _tmp0_;
#line 7563 "mutter-clutter-14.vapi"
	clutter_color_from_string (color, str);
#line 7564 "mutter-clutter-14.vapi"
	result = color;
#line 7564 "mutter-clutter-14.vapi"
	return result;
#line 508 "WindowSwitcher.c"
}

static void
_vala_ClutterColor_free (ClutterColor* self)
{
#line 167 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	g_boxed_free (clutter_color_get_type (), self);
#line 516 "WindowSwitcher.c"
}

static void
gala_window_switcher_real_draw (GalaCanvasActor* base,
                                cairo_t* ctx,
                                gint width,
                                gint height)
{
	GalaWindowSwitcher * self;
	GdkRGBA background_color = {0};
	GdkRGBA border_color = {0};
	gchar* caption_color = NULL;
	gchar* _tmp0_;
	GdkRGBA highlight_color = {0};
	GalaDrawingStyleManager* _tmp1_;
	GalaDrawingStyleManagerColorScheme _tmp2_;
	GalaDrawingStyleManagerColorScheme _tmp3_;
	gfloat stroke_width = 0.0F;
	ClutterText* _tmp5_;
	const gchar* _tmp6_;
	ClutterColor* _tmp7_;
	ClutterColor* _tmp8_;
	ClutterColor _tmp9_;
	GdkRGBA _tmp10_;
	GdkRGBA _tmp11_;
	GdkRGBA _tmp12_;
	GdkRGBA _tmp13_;
	GdkRGBA _tmp14_;
	GdkRGBA _tmp15_;
	GdkRGBA _tmp16_;
	GdkRGBA _tmp17_;
	GdkRGBA _tmp18_;
	GdkRGBA _tmp19_;
	GdkRGBA _tmp20_;
	GdkRGBA _tmp21_;
#line 149 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	self = (GalaWindowSwitcher*) base;
#line 149 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	g_return_if_fail (ctx != NULL);
#line 150 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	background_color = GALA_DRAWING_COLOR_LIGHT_BACKGROUND;
#line 151 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	border_color = GALA_DRAWING_COLOR_LIGHT_BORDER;
#line 152 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp0_ = g_strdup ("#2e2e31");
#line 152 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	caption_color = _tmp0_;
#line 153 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	highlight_color = GALA_DRAWING_COLOR_LIGHT_HIGHLIGHT;
#line 155 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp1_ = self->priv->style_manager;
#line 155 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp2_ = gala_drawing_style_manager_get_prefers_color_scheme (_tmp1_);
#line 155 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp3_ = _tmp2_;
#line 155 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	if (_tmp3_ == GALA_DRAWING_STYLE_MANAGER_COLOR_SCHEME_DARK) {
#line 574 "WindowSwitcher.c"
		gchar* _tmp4_;
#line 156 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		background_color = GALA_DRAWING_COLOR_DARK_BACKGROUND;
#line 157 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		border_color = GALA_DRAWING_COLOR_DARK_BORDER;
#line 158 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		_tmp4_ = g_strdup ("#fafafa");
#line 158 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		_g_free0 (caption_color);
#line 158 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		caption_color = _tmp4_;
#line 159 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		highlight_color = GALA_DRAWING_COLOR_DARK_HIGHLIGHT;
#line 588 "WindowSwitcher.c"
	}
#line 162 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	stroke_width = self->priv->scaling_factor;
#line 167 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp5_ = self->priv->caption;
#line 167 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp6_ = caption_color;
#line 167 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp7_ = _vala_clutter_color_from_string (_tmp6_);
#line 167 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp8_ = _tmp7_;
#line 167 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp9_ = *_tmp8_;
#line 167 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	clutter_text_set_color (_tmp5_, &_tmp9_);
#line 167 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	__vala_ClutterColor_free0 (_tmp8_);
#line 170 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	cairo_save (ctx);
#line 171 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	cairo_set_operator (ctx, CAIRO_OPERATOR_CLEAR);
#line 172 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	cairo_paint (ctx);
#line 173 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	cairo_clip (ctx);
#line 174 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	cairo_reset_clip (ctx);
#line 176 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	cairo_set_operator (ctx, CAIRO_OPERATOR_SOURCE);
#line 179 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	gala_drawing_utilities_cairo_rounded_rectangle (ctx, 0.5, 0.5, (gdouble) (width - stroke_width), (gdouble) (height - stroke_width), (gdouble) gala_internal_utils_scale_to_int (9, self->priv->scaling_factor));
#line 186 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp10_ = background_color;
#line 186 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp11_ = background_color;
#line 186 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp12_ = background_color;
#line 186 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp13_ = background_color;
#line 186 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	cairo_set_source_rgba (ctx, _tmp10_.red, _tmp11_.green, _tmp12_.blue, _tmp13_.alpha);
#line 192 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	cairo_fill_preserve (ctx);
#line 194 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	cairo_set_line_width (ctx, (gdouble) stroke_width);
#line 195 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp14_ = border_color;
#line 195 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp15_ = border_color;
#line 195 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp16_ = border_color;
#line 195 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp17_ = border_color;
#line 195 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	cairo_set_source_rgba (ctx, _tmp14_.red, _tmp15_.green, _tmp16_.blue, _tmp17_.alpha);
#line 201 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	cairo_stroke (ctx);
#line 202 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	cairo_restore (ctx);
#line 205 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	gala_drawing_utilities_cairo_rounded_rectangle (ctx, stroke_width + 0.5, stroke_width + 0.5, (gdouble) ((width - (stroke_width * 2)) - 1), (gdouble) ((height - (stroke_width * 2)) - 1), (gdouble) gala_internal_utils_scale_to_int (8, self->priv->scaling_factor));
#line 212 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	cairo_set_line_width (ctx, (gdouble) stroke_width);
#line 213 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp18_ = highlight_color;
#line 213 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp19_ = highlight_color;
#line 213 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp20_ = highlight_color;
#line 213 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp21_ = highlight_color;
#line 213 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	cairo_set_source_rgba (ctx, _tmp18_.red, _tmp19_.green, _tmp20_.blue, _tmp21_.alpha);
#line 219 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	cairo_stroke (ctx);
#line 220 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	cairo_restore (ctx);
#line 149 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_g_free0 (caption_color);
#line 668 "WindowSwitcher.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 232 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	return self ? g_object_ref (self) : NULL;
#line 676 "WindowSwitcher.c"
}

void
gala_window_switcher_handle_switch_windows (MetaDisplay* display,
                                            MetaWindow* window,
                                            ClutterKeyEvent* event,
                                            MetaKeyBinding* binding,
                                            GalaWindowSwitcher* self)
{
	MetaWorkspace* workspace = NULL;
	MetaWorkspaceManager* _tmp0_;
	MetaWorkspace* _tmp1_;
	MetaWorkspace* _tmp2_;
	guint mask = 0U;
	gboolean _tmp3_;
	gchar* binding_name = NULL;
	const gchar* _tmp7_;
	gchar* _tmp8_;
	gboolean backward = FALSE;
	const gchar* _tmp9_;
#line 224 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	g_return_if_fail (self != NULL);
#line 224 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	g_return_if_fail (display != NULL);
#line 224 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	g_return_if_fail (event != NULL);
#line 224 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	g_return_if_fail (binding != NULL);
#line 228 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	if (self->priv->handling_gesture) {
#line 229 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		return;
#line 709 "WindowSwitcher.c"
	}
#line 232 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp0_ = meta_display_get_workspace_manager (display);
#line 232 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp1_ = meta_workspace_manager_get_active_workspace (_tmp0_);
#line 232 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp2_ = _g_object_ref0 (_tmp1_);
#line 232 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	workspace = _tmp2_;
#line 235 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	mask = meta_key_binding_get_mask (binding);
#line 236 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	if (mask == ((guint) 0)) {
#line 237 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		self->priv->modifier_mask = 0;
#line 725 "WindowSwitcher.c"
	} else {
#line 239 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		self->priv->modifier_mask = 1;
#line 240 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		while (TRUE) {
#line 240 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
			if (!(mask > ((guint) 1))) {
#line 240 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
				break;
#line 735 "WindowSwitcher.c"
			}
#line 241 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
			mask >>= (guint) 1;
#line 242 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
			self->priv->modifier_mask = self->priv->modifier_mask << 1;
#line 741 "WindowSwitcher.c"
		}
	}
#line 246 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp3_ = self->priv->_opened;
#line 246 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	if (!_tmp3_) {
#line 748 "WindowSwitcher.c"
		gboolean windows_exist = FALSE;
		const gchar* _tmp4_;
#line 248 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		_tmp4_ = meta_key_binding_get_name (binding);
#line 248 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		if (g_str_has_prefix (_tmp4_, "switch-group")) {
#line 755 "WindowSwitcher.c"
			MetaWorkspace* _tmp5_;
#line 249 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
			_tmp5_ = workspace;
#line 249 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
			windows_exist = gala_window_switcher_collect_current_windows (self, display, _tmp5_);
#line 761 "WindowSwitcher.c"
		} else {
			MetaWorkspace* _tmp6_;
#line 251 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
			_tmp6_ = workspace;
#line 251 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
			windows_exist = gala_window_switcher_collect_all_windows (self, display, _tmp6_);
#line 768 "WindowSwitcher.c"
		}
#line 254 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		if (!windows_exist) {
#line 255 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
			_g_object_unref0 (workspace);
#line 255 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
			return;
#line 776 "WindowSwitcher.c"
		}
#line 258 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		gala_window_switcher_open_switcher (self);
#line 780 "WindowSwitcher.c"
	}
#line 261 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp7_ = meta_key_binding_get_name (binding);
#line 261 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp8_ = g_strdup (_tmp7_);
#line 261 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	binding_name = _tmp8_;
#line 262 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp9_ = binding_name;
#line 262 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	backward = g_str_has_suffix (_tmp9_, "-backward");
#line 264 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	gala_window_switcher_next_window (self, backward);
#line 224 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_g_free0 (binding_name);
#line 224 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_g_object_unref0 (workspace);
#line 798 "WindowSwitcher.c"
}

static Block77Data*
block77_data_ref (Block77Data* _data77_)
{
#line 267 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	g_atomic_int_inc (&_data77_->_ref_count_);
#line 267 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	return _data77_;
#line 808 "WindowSwitcher.c"
}

static void
block77_data_unref (void * _userdata_)
{
	Block77Data* _data77_;
	_data77_ = (Block77Data*) _userdata_;
#line 267 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	if (g_atomic_int_dec_and_test (&_data77_->_ref_count_)) {
#line 818 "WindowSwitcher.c"
		GalaWindowSwitcher* self;
#line 267 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		self = _data77_->self;
#line 267 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		_g_object_unref0 (self);
#line 267 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		g_slice_free (Block77Data, _data77_);
#line 826 "WindowSwitcher.c"
	}
}

static void
__lambda81_ (Block77Data* _data77_,
             gdouble percentage)
{
	GalaWindowSwitcher* self;
	gfloat window_index = 0.0F;
	ClutterActor* _tmp0_;
#line 282 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	self = _data77_->self;
#line 283 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	window_index = gala_gesture_tracker_animation_value ((gfloat) 0, (gfloat) GALA_WINDOW_SWITCHER_GESTURE_RANGE_LIMIT, percentage, TRUE);
#line 285 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp0_ = self->priv->container;
#line 285 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	if (window_index >= ((gfloat) clutter_actor_get_n_children (_tmp0_))) {
#line 286 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		return;
#line 847 "WindowSwitcher.c"
	}
#line 289 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	if (window_index > ((gfloat) _data77_->last_window_index)) {
#line 290 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		while (TRUE) {
#line 853 "WindowSwitcher.c"
			gint _tmp1_;
#line 290 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
			if (!(((gfloat) _data77_->last_window_index) < window_index)) {
#line 290 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
				break;
#line 859 "WindowSwitcher.c"
			}
#line 291 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
			gala_window_switcher_next_window (self, _data77_->direction == GALA_GESTURE_DIRECTION_LEFT);
#line 292 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
			_tmp1_ = _data77_->last_window_index;
#line 292 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
			_data77_->last_window_index = _tmp1_ + 1;
#line 867 "WindowSwitcher.c"
		}
	} else {
#line 294 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		if (window_index < ((gfloat) _data77_->last_window_index)) {
#line 295 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
			while (TRUE) {
#line 874 "WindowSwitcher.c"
				gint _tmp2_;
#line 295 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
				if (!(((gfloat) _data77_->last_window_index) > window_index)) {
#line 295 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
					break;
#line 880 "WindowSwitcher.c"
				}
#line 296 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
				gala_window_switcher_next_window (self, _data77_->direction == GALA_GESTURE_DIRECTION_RIGHT);
#line 297 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
				_tmp2_ = _data77_->last_window_index;
#line 297 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
				_data77_->last_window_index = _tmp2_ - 1;
#line 888 "WindowSwitcher.c"
			}
		}
	}
}

static void
___lambda81__gala_gesture_tracker_on_update (gdouble percentage,
                                             gpointer self)
{
#line 282 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	__lambda81_ (self, percentage);
#line 900 "WindowSwitcher.c"
}

static void
__lambda82_ (GalaWindowSwitcher* self,
             gdouble percentage,
             gint cancel_action,
             gint calculated_duration)
{
	GalaWindowManager* _tmp0_;
	MetaDisplay* _tmp1_;
#line 303 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	self->priv->handling_gesture = FALSE;
#line 304 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp0_ = self->priv->_wm;
#line 304 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp1_ = meta_plugin_get_display ((MetaPlugin*) _tmp0_);
#line 304 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	gala_window_switcher_close_switcher (self, meta_display_get_current_time (_tmp1_), FALSE);
#line 919 "WindowSwitcher.c"
}

static void
___lambda82__gala_gesture_tracker_on_end (gdouble percentage,
                                          gint completions,
                                          gint calculated_duration,
                                          gpointer self)
{
#line 302 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	__lambda82_ ((GalaWindowSwitcher*) self, percentage, completions, calculated_duration);
#line 930 "WindowSwitcher.c"
}

void
gala_window_switcher_handle_gesture (GalaWindowSwitcher* self,
                                     GalaGestureDirection direction)
{
	Block77Data* _data77_;
	MetaDisplay* display = NULL;
	GalaWindowManager* _tmp0_;
	MetaDisplay* _tmp1_;
	MetaWorkspaceManager* workspace_manager = NULL;
	MetaDisplay* _tmp2_;
	MetaWorkspaceManager* _tmp3_;
	MetaWorkspace* active_workspace = NULL;
	MetaWorkspaceManager* _tmp4_;
	MetaWorkspace* _tmp5_;
	gboolean windows_exist = FALSE;
	MetaDisplay* _tmp6_;
	MetaWorkspace* _tmp7_;
	gint _tmp8_ = 0;
	GalaGestureTrackerOnUpdate on_animation_update = NULL;
	gpointer on_animation_update_target;
	GDestroyNotify on_animation_update_target_destroy_notify;
	GalaGestureTrackerOnEnd on_animation_end = NULL;
	gpointer on_animation_end_target;
	GDestroyNotify on_animation_end_target_destroy_notify;
	GalaGestureTracker* _tmp9_;
	GalaGestureTrackerOnUpdate _tmp10_;
	gpointer _tmp10__target;
	GDestroyNotify _tmp10__target_destroy_notify;
	GalaGestureTrackerOnEnd _tmp11_;
	gpointer _tmp11__target;
	GDestroyNotify _tmp11__target_destroy_notify;
#line 267 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	g_return_if_fail (self != NULL);
#line 267 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_data77_ = g_slice_new0 (Block77Data);
#line 267 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_data77_->_ref_count_ = 1;
#line 267 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_data77_->self = g_object_ref (self);
#line 267 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_data77_->direction = direction;
#line 268 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	self->priv->handling_gesture = TRUE;
#line 270 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp0_ = self->priv->_wm;
#line 270 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp1_ = meta_plugin_get_display ((MetaPlugin*) _tmp0_);
#line 270 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	display = _tmp1_;
#line 271 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp2_ = display;
#line 271 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp3_ = meta_display_get_workspace_manager (_tmp2_);
#line 271 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	workspace_manager = _tmp3_;
#line 272 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp4_ = workspace_manager;
#line 272 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp5_ = meta_workspace_manager_get_active_workspace (_tmp4_);
#line 272 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	active_workspace = _tmp5_;
#line 274 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp6_ = display;
#line 274 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp7_ = active_workspace;
#line 274 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	windows_exist = gala_window_switcher_collect_all_windows (self, _tmp6_, _tmp7_);
#line 275 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	if (!windows_exist) {
#line 276 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		block77_data_unref (_data77_);
#line 276 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		_data77_ = NULL;
#line 276 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		return;
#line 1008 "WindowSwitcher.c"
	}
#line 278 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	gala_window_switcher_open_switcher (self);
#line 281 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	if (_data77_->direction == GALA_GESTURE_DIRECTION_RIGHT) {
#line 281 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		_tmp8_ = 0;
#line 1016 "WindowSwitcher.c"
	} else {
#line 281 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		_tmp8_ = -1;
#line 1020 "WindowSwitcher.c"
	}
#line 281 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_data77_->last_window_index = _tmp8_;
#line 282 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	on_animation_update = ___lambda81__gala_gesture_tracker_on_update;
#line 282 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	on_animation_update_target = block77_data_ref (_data77_);
#line 282 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	on_animation_update_target_destroy_notify = block77_data_unref;
#line 302 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	on_animation_end = ___lambda82__gala_gesture_tracker_on_end;
#line 302 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	on_animation_end_target = g_object_ref (self);
#line 302 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	on_animation_end_target_destroy_notify = g_object_unref;
#line 307 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp9_ = self->priv->_gesture_tracker;
#line 307 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp10_ = on_animation_update;
#line 307 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp10__target = on_animation_update_target;
#line 307 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp10__target_destroy_notify = on_animation_update_target_destroy_notify;
#line 307 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	on_animation_update = NULL;
#line 307 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	on_animation_update_target = NULL;
#line 307 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	on_animation_update_target_destroy_notify = NULL;
#line 307 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp11_ = on_animation_end;
#line 307 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp11__target = on_animation_end_target;
#line 307 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp11__target_destroy_notify = on_animation_end_target_destroy_notify;
#line 307 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	on_animation_end = NULL;
#line 307 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	on_animation_end_target = NULL;
#line 307 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	on_animation_end_target_destroy_notify = NULL;
#line 307 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	gala_gesture_tracker_connect_handlers (_tmp9_, NULL, NULL, NULL, _tmp10_, _tmp10__target, _tmp10__target_destroy_notify, _tmp11_, _tmp11__target, _tmp11__target_destroy_notify);
#line 267 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	(on_animation_end_target_destroy_notify == NULL) ? NULL : (on_animation_end_target_destroy_notify (on_animation_end_target), NULL);
#line 267 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	on_animation_end = NULL;
#line 267 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	on_animation_end_target = NULL;
#line 267 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	on_animation_end_target_destroy_notify = NULL;
#line 267 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	(on_animation_update_target_destroy_notify == NULL) ? NULL : (on_animation_update_target_destroy_notify (on_animation_update_target), NULL);
#line 267 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	on_animation_update = NULL;
#line 267 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	on_animation_update_target = NULL;
#line 267 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	on_animation_update_target_destroy_notify = NULL;
#line 267 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	block77_data_unref (_data77_);
#line 267 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_data77_ = NULL;
#line 1084 "WindowSwitcher.c"
}

static gboolean
gala_window_switcher_collect_all_windows (GalaWindowSwitcher* self,
                                          MetaDisplay* display,
                                          MetaWorkspace* workspace)
{
	GList* windows = NULL;
	GList* _tmp0_;
	GList* _tmp1_;
	MetaWindow* current_window = NULL;
	MetaWindow* _tmp2_;
	MetaWindow* _tmp3_;
	ClutterActor* _tmp4_;
	GList* _tmp5_;
	gboolean result;
#line 310 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 310 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	g_return_val_if_fail (display != NULL, FALSE);
#line 311 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp0_ = meta_display_get_tab_list (display, META_TAB_LIST_NORMAL, workspace);
#line 311 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	windows = _tmp0_;
#line 312 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp1_ = windows;
#line 312 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	if (_tmp1_ == NULL) {
#line 313 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		result = FALSE;
#line 313 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		(windows == NULL) ? NULL : (windows = (g_list_free (windows), NULL));
#line 313 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		return result;
#line 1119 "WindowSwitcher.c"
	}
#line 316 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp2_ = meta_display_get_tab_current (display, META_TAB_LIST_NORMAL, workspace);
#line 316 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	current_window = _tmp2_;
#line 317 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp3_ = current_window;
#line 317 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	if (_tmp3_ == NULL) {
#line 318 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		gala_window_switcher_set_current_icon (self, NULL);
#line 1131 "WindowSwitcher.c"
	}
#line 321 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp4_ = self->priv->container;
#line 321 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	clutter_actor_remove_all_children (_tmp4_);
#line 323 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp5_ = windows;
#line 1139 "WindowSwitcher.c"
	{
		GList* window_collection = NULL;
		GList* window_it = NULL;
#line 323 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		window_collection = _tmp5_;
#line 323 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		for (window_it = window_collection; window_it != NULL; window_it = window_it->next) {
#line 1147 "WindowSwitcher.c"
			MetaWindow* window = NULL;
#line 323 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
			window = (MetaWindow*) window_it->data;
#line 1151 "WindowSwitcher.c"
			{
				GalaWindowSwitcherIcon* icon = NULL;
				MetaWindow* _tmp6_;
				GalaWindowSwitcherIcon* _tmp7_;
				MetaWindow* _tmp8_;
				MetaWindow* _tmp9_;
				GalaWindowSwitcherIcon* _tmp11_;
#line 324 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
				_tmp6_ = window;
#line 324 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
				_tmp7_ = gala_window_switcher_icon_new (_tmp6_, GALA_WINDOW_SWITCHER_ICON_SIZE, self->priv->scaling_factor);
#line 324 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
				g_object_ref_sink (_tmp7_);
#line 324 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
				icon = _tmp7_;
#line 325 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
				_tmp8_ = window;
#line 325 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
				_tmp9_ = current_window;
#line 325 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
				if (_tmp8_ == _tmp9_) {
#line 1173 "WindowSwitcher.c"
					GalaWindowSwitcherIcon* _tmp10_;
#line 326 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
					_tmp10_ = icon;
#line 326 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
					gala_window_switcher_set_current_icon (self, _tmp10_);
#line 1179 "WindowSwitcher.c"
				}
#line 329 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
				_tmp11_ = icon;
#line 329 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
				gala_window_switcher_add_icon (self, _tmp11_);
#line 323 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
				_g_object_unref0 (icon);
#line 1187 "WindowSwitcher.c"
			}
		}
	}
#line 332 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	result = TRUE;
#line 332 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	(windows == NULL) ? NULL : (windows = (g_list_free (windows), NULL));
#line 332 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	return result;
#line 1197 "WindowSwitcher.c"
}

static gboolean
gala_window_switcher_collect_current_windows (GalaWindowSwitcher* self,
                                              MetaDisplay* display,
                                              MetaWorkspace* workspace)
{
	GList* windows = NULL;
	GList* _tmp0_;
	GList* _tmp1_;
	MetaWindow* current_window = NULL;
	MetaWindow* _tmp2_;
	MetaWindow* _tmp3_;
	ClutterActor* _tmp4_;
	GalaWindowTracker* window_tracker = NULL;
	GalaWindowManager* _tmp5_;
	GalaWindowTracker* _tmp6_;
	GalaWindowTracker* _tmp7_;
	GalaApp* app = NULL;
	GalaWindowTracker* _tmp8_;
	MetaWindow* _tmp9_;
	GalaApp* _tmp10_;
	GList* _tmp11_;
	gboolean result;
#line 335 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 335 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	g_return_val_if_fail (display != NULL, FALSE);
#line 336 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp0_ = meta_display_get_tab_list (display, META_TAB_LIST_NORMAL, workspace);
#line 336 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	windows = _tmp0_;
#line 337 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp1_ = windows;
#line 337 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	if (_tmp1_ == NULL) {
#line 338 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		result = FALSE;
#line 338 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		(windows == NULL) ? NULL : (windows = (g_list_free (windows), NULL));
#line 338 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		return result;
#line 1240 "WindowSwitcher.c"
	}
#line 341 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp2_ = meta_display_get_tab_current (display, META_TAB_LIST_NORMAL, workspace);
#line 341 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	current_window = _tmp2_;
#line 342 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp3_ = current_window;
#line 342 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	if (_tmp3_ == NULL) {
#line 343 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		gala_window_switcher_set_current_icon (self, NULL);
#line 344 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		result = FALSE;
#line 344 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		(windows == NULL) ? NULL : (windows = (g_list_free (windows), NULL));
#line 344 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		return result;
#line 1258 "WindowSwitcher.c"
	}
#line 347 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp4_ = self->priv->container;
#line 347 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	clutter_actor_remove_all_children (_tmp4_);
#line 349 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp5_ = self->priv->_wm;
#line 349 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp6_ = gala_window_manager_gala_get_window_tracker (G_TYPE_CHECK_INSTANCE_CAST (_tmp5_, GALA_TYPE_WINDOW_MANAGER_GALA, GalaWindowManagerGala));
#line 349 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp7_ = _tmp6_;
#line 349 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	window_tracker = _tmp7_;
#line 350 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp8_ = window_tracker;
#line 350 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp9_ = current_window;
#line 350 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp10_ = gala_window_tracker_get_app_for_window (_tmp8_, _tmp9_);
#line 350 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	app = _tmp10_;
#line 351 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp11_ = windows;
#line 1282 "WindowSwitcher.c"
	{
		GList* window_collection = NULL;
		GList* window_it = NULL;
#line 351 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		window_collection = _tmp11_;
#line 351 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		for (window_it = window_collection; window_it != NULL; window_it = window_it->next) {
#line 1290 "WindowSwitcher.c"
			MetaWindow* window = NULL;
#line 351 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
			window = (MetaWindow*) window_it->data;
#line 1294 "WindowSwitcher.c"
			{
				GalaWindowTracker* _tmp12_;
				MetaWindow* _tmp13_;
				GalaApp* _tmp14_;
				GalaApp* _tmp15_;
				GalaApp* _tmp16_;
				gboolean _tmp17_;
#line 352 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
				_tmp12_ = window_tracker;
#line 352 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
				_tmp13_ = window;
#line 352 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
				_tmp14_ = gala_window_tracker_get_app_for_window (_tmp12_, _tmp13_);
#line 352 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
				_tmp15_ = _tmp14_;
#line 352 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
				_tmp16_ = app;
#line 352 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
				_tmp17_ = _tmp15_ == _tmp16_;
#line 352 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
				_g_object_unref0 (_tmp15_);
#line 352 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
				if (_tmp17_) {
#line 1318 "WindowSwitcher.c"
					GalaWindowSwitcherIcon* icon = NULL;
					MetaWindow* _tmp18_;
					GalaWindowSwitcherIcon* _tmp19_;
					MetaWindow* _tmp20_;
					MetaWindow* _tmp21_;
					GalaWindowSwitcherIcon* _tmp23_;
#line 353 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
					_tmp18_ = window;
#line 353 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
					_tmp19_ = gala_window_switcher_icon_new (_tmp18_, GALA_WINDOW_SWITCHER_ICON_SIZE, self->priv->scaling_factor);
#line 353 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
					g_object_ref_sink (_tmp19_);
#line 353 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
					icon = _tmp19_;
#line 354 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
					_tmp20_ = window;
#line 354 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
					_tmp21_ = current_window;
#line 354 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
					if (_tmp20_ == _tmp21_) {
#line 1339 "WindowSwitcher.c"
						GalaWindowSwitcherIcon* _tmp22_;
#line 355 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
						_tmp22_ = icon;
#line 355 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
						gala_window_switcher_set_current_icon (self, _tmp22_);
#line 1345 "WindowSwitcher.c"
					}
#line 358 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
					_tmp23_ = icon;
#line 358 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
					gala_window_switcher_add_icon (self, _tmp23_);
#line 352 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
					_g_object_unref0 (icon);
#line 1353 "WindowSwitcher.c"
				}
			}
		}
	}
#line 362 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	result = TRUE;
#line 362 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_g_object_unref0 (app);
#line 362 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	(windows == NULL) ? NULL : (windows = (g_list_free (windows), NULL));
#line 362 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	return result;
#line 1366 "WindowSwitcher.c"
}

static gboolean
__lambda79_ (GalaWindowSwitcher* self,
             ClutterActor* _icon,
             ClutterEvent* event)
{
	gboolean _tmp0_ = FALSE;
	GalaWindowSwitcherIcon* _tmp1_;
	GalaWindowSwitcherIcon* _tmp2_;
	gboolean result;
#line 369 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	g_return_val_if_fail (_icon != NULL, FALSE);
#line 369 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	g_return_val_if_fail (event != NULL, FALSE);
#line 370 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp1_ = gala_window_switcher_get_current_icon (self);
#line 370 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp2_ = _tmp1_;
#line 370 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	if (G_TYPE_CHECK_INSTANCE_CAST (_tmp2_, clutter_actor_get_type (), ClutterActor) != _icon) {
#line 370 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		_tmp0_ = !self->priv->handling_gesture;
#line 1390 "WindowSwitcher.c"
	} else {
#line 370 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		_tmp0_ = FALSE;
#line 1394 "WindowSwitcher.c"
	}
#line 370 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	if (_tmp0_) {
#line 371 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		gala_window_switcher_set_current_icon (self, G_TYPE_CHECK_INSTANCE_CAST (_icon, GALA_TYPE_WINDOW_SWITCHER_ICON, GalaWindowSwitcherIcon));
#line 1400 "WindowSwitcher.c"
	}
#line 374 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	result = CLUTTER_EVENT_PROPAGATE;
#line 374 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	return result;
#line 1406 "WindowSwitcher.c"
}

static gboolean
___lambda79__clutter_actor_motion_event (ClutterActor* _sender,
                                         ClutterEvent* event,
                                         gpointer self)
{
	gboolean result;
	result = __lambda79_ ((GalaWindowSwitcher*) self, _sender, event);
#line 369 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	return result;
#line 1418 "WindowSwitcher.c"
}

static void
gala_window_switcher_add_icon (GalaWindowSwitcher* self,
                               GalaWindowSwitcherIcon* icon)
{
	ClutterActor* _tmp0_;
	AtkObject* _tmp1_;
	ClutterActor* _tmp2_;
	AtkObject* _tmp3_;
#line 365 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	g_return_if_fail (self != NULL);
#line 365 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	g_return_if_fail (icon != NULL);
#line 366 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp0_ = self->priv->container;
#line 366 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	clutter_actor_add_child (_tmp0_, (ClutterActor*) icon);
#line 367 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp1_ = clutter_actor_get_accessible ((ClutterActor*) icon);
#line 367 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp2_ = self->priv->container;
#line 367 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp3_ = clutter_actor_get_accessible (_tmp2_);
#line 367 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	g_object_set (_tmp1_, "accessible-parent", _tmp3_, NULL);
#line 369 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	g_signal_connect_object ((ClutterActor*) icon, "motion-event", (GCallback) ___lambda79__clutter_actor_motion_event, self, 0);
#line 1447 "WindowSwitcher.c"
}

static void
gala_window_switcher_open_switcher (GalaWindowSwitcher* self)
{
	ClutterActor* _tmp0_;
	gboolean _tmp3_;
	gfloat width = 0.0F;
	gfloat height = 0.0F;
	gfloat _tmp4_ = 0.0F;
	gfloat _tmp5_ = 0.0F;
	MetaDisplay* display = NULL;
	GalaWindowManager* _tmp6_;
	MetaDisplay* _tmp7_;
	gint monitor = 0;
	MetaDisplay* _tmp8_;
	MtkRectangle geom = {0};
	MetaDisplay* _tmp9_;
	MtkRectangle _tmp10_ = {0};
	MtkRectangle _tmp11_;
	MtkRectangle _tmp12_;
	MtkRectangle _tmp13_;
	MtkRectangle _tmp14_;
#line 378 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	g_return_if_fail (self != NULL);
#line 379 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp0_ = self->priv->container;
#line 379 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	if (clutter_actor_get_n_children (_tmp0_) == 0) {
#line 1477 "WindowSwitcher.c"
		ClutterBackend* _tmp1_;
		ClutterSeat* _tmp2_;
#line 380 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		_tmp1_ = clutter_get_default_backend ();
#line 380 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		_tmp2_ = clutter_backend_get_default_seat (_tmp1_);
#line 380 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		clutter_seat_bell_notify (_tmp2_);
#line 381 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		return;
#line 1488 "WindowSwitcher.c"
	}
#line 384 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp3_ = self->priv->_opened;
#line 384 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	if (_tmp3_) {
#line 385 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		return;
#line 1496 "WindowSwitcher.c"
	}
#line 390 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	g_object_set ((ClutterActor*) self, "visible", TRUE, NULL);
#line 393 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	clutter_actor_get_preferred_size ((ClutterActor*) self, NULL, NULL, &_tmp4_, &_tmp5_);
#line 393 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	width = _tmp4_;
#line 393 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	height = _tmp5_;
#line 395 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp6_ = self->priv->_wm;
#line 395 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp7_ = meta_plugin_get_display ((MetaPlugin*) _tmp6_);
#line 395 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	display = _tmp7_;
#line 396 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp8_ = display;
#line 396 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	monitor = meta_display_get_current_monitor (_tmp8_);
#line 397 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp9_ = display;
#line 397 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	meta_display_get_monitor_geometry (_tmp9_, monitor, &_tmp10_);
#line 397 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	geom = _tmp10_;
#line 399 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp11_ = geom;
#line 399 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp12_ = geom;
#line 399 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp13_ = geom;
#line 399 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp14_ = geom;
#line 399 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	clutter_actor_set_position ((ClutterActor*) self, (gfloat) ((gint) (_tmp11_.x + ((_tmp12_.width - width) / 2))), (gfloat) ((gint) (_tmp13_.y + ((_tmp14_.height - height) / 2))));
#line 404 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	gala_window_switcher_toggle_display (self, TRUE);
#line 1534 "WindowSwitcher.c"
}

static void
gala_window_switcher_toggle_display (GalaWindowSwitcher* self,
                                     gboolean show)
{
	gboolean _tmp0_;
	gint _tmp4_ = 0;
#line 407 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	g_return_if_fail (self != NULL);
#line 408 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp0_ = self->priv->_opened;
#line 408 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	if (_tmp0_ == show) {
#line 409 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		return;
#line 1551 "WindowSwitcher.c"
	}
#line 412 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	gala_window_switcher_set_opened (self, show);
#line 413 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	if (show) {
#line 414 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		gala_window_switcher_push_modal (self);
#line 1559 "WindowSwitcher.c"
	} else {
		GalaWindowManager* _tmp1_;
		GalaModalProxy* _tmp2_;
		ClutterStage* _tmp3_;
#line 416 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		_tmp1_ = self->priv->_wm;
#line 416 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		_tmp2_ = self->priv->modal_proxy;
#line 416 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		gala_window_manager_pop_modal (_tmp1_, _tmp2_);
#line 417 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		_tmp3_ = clutter_actor_get_stage ((ClutterActor*) self);
#line 417 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		clutter_stage_set_key_focus (_tmp3_, NULL);
#line 1574 "WindowSwitcher.c"
	}
#line 420 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	clutter_actor_save_easing_state ((ClutterActor*) self);
#line 421 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	clutter_actor_set_easing_duration ((ClutterActor*) self, animations_settings_get_animation_duration ((guint) GALA_WINDOW_SWITCHER_ANIMATION_DURATION));
#line 422 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	if (show) {
#line 422 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		_tmp4_ = 255;
#line 1584 "WindowSwitcher.c"
	} else {
#line 422 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		_tmp4_ = 0;
#line 1588 "WindowSwitcher.c"
	}
#line 422 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	clutter_actor_set_opacity ((ClutterActor*) self, (guint) _tmp4_);
#line 423 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	clutter_actor_restore_easing_state ((ClutterActor*) self);
#line 1594 "WindowSwitcher.c"
}

static gboolean
__lambda80_ (GalaWindowSwitcher* self,
             MetaKeyBinding* binding)
{
	MetaKeyBindingAction action = 0;
	const gchar* _tmp0_;
	gboolean result;
#line 428 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	g_return_val_if_fail (binding != NULL, FALSE);
#line 429 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp0_ = meta_key_binding_get_name (binding);
#line 429 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	action = meta_prefs_get_keybinding_action (_tmp0_);
#line 431 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	switch (action) {
#line 431 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		case META_KEYBINDING_ACTION_NONE:
#line 431 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		case META_KEYBINDING_ACTION_LOCATE_POINTER_KEY:
#line 431 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		case META_KEYBINDING_ACTION_SWITCH_APPLICATIONS:
#line 431 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		case META_KEYBINDING_ACTION_SWITCH_APPLICATIONS_BACKWARD:
#line 431 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		case META_KEYBINDING_ACTION_SWITCH_WINDOWS:
#line 431 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		case META_KEYBINDING_ACTION_SWITCH_WINDOWS_BACKWARD:
#line 431 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		case META_KEYBINDING_ACTION_SWITCH_GROUP:
#line 431 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		case META_KEYBINDING_ACTION_SWITCH_GROUP_BACKWARD:
#line 1628 "WindowSwitcher.c"
		{
#line 440 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
			result = FALSE;
#line 440 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
			return result;
#line 1634 "WindowSwitcher.c"
		}
		default:
		{
#line 442 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
			break;
#line 1640 "WindowSwitcher.c"
		}
	}
#line 445 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	result = TRUE;
#line 445 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	return result;
#line 1647 "WindowSwitcher.c"
}

static gboolean
___lambda80__gala_keybinding_filter (MetaKeyBinding* binding,
                                     gpointer self)
{
	gboolean result;
	result = __lambda80_ ((GalaWindowSwitcher*) self, binding);
#line 428 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	return result;
#line 1658 "WindowSwitcher.c"
}

static void
gala_window_switcher_push_modal (GalaWindowSwitcher* self)
{
	GalaWindowManager* _tmp0_;
	GalaModalProxy* _tmp1_;
	GalaModalProxy* _tmp2_;
#line 426 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	g_return_if_fail (self != NULL);
#line 427 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp0_ = self->priv->_wm;
#line 427 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp1_ = gala_window_manager_push_modal (_tmp0_, (ClutterActor*) self);
#line 427 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_g_object_unref0 (self->priv->modal_proxy);
#line 427 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	self->priv->modal_proxy = _tmp1_;
#line 428 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp2_ = self->priv->modal_proxy;
#line 428 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	gala_modal_proxy_set_keybinding_filter (_tmp2_, ___lambda80__gala_keybinding_filter, self);
#line 1681 "WindowSwitcher.c"
}

static void
gala_window_switcher_close_switcher (GalaWindowSwitcher* self,
                                     guint32 time,
                                     gboolean cancel)
{
	gboolean _tmp0_;
	MetaWindow* window = NULL;
	GalaWindowSwitcherIcon* _tmp1_;
	GalaWindowSwitcherIcon* _tmp2_;
	MetaWindow* _tmp3_;
	MetaWindow* _tmp4_;
	MetaWindow* _tmp5_;
	MetaWindow* _tmp6_;
#line 450 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	g_return_if_fail (self != NULL);
#line 451 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp0_ = self->priv->_opened;
#line 451 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	if (!_tmp0_) {
#line 452 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		return;
#line 1705 "WindowSwitcher.c"
	}
#line 455 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp1_ = gala_window_switcher_get_current_icon (self);
#line 455 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp2_ = _tmp1_;
#line 455 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp3_ = gala_window_switcher_icon_get_window (_tmp2_);
#line 455 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp4_ = _tmp3_;
#line 455 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp5_ = _g_object_ref0 (_tmp4_);
#line 455 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	window = _tmp5_;
#line 456 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp6_ = window;
#line 456 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	if (_tmp6_ == NULL) {
#line 457 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		_g_object_unref0 (window);
#line 457 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		return;
#line 1727 "WindowSwitcher.c"
	}
#line 460 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	if (!cancel) {
#line 1731 "WindowSwitcher.c"
		MetaWorkspace* workspace = NULL;
		MetaWindow* _tmp7_;
		MetaWorkspace* _tmp8_;
		MetaWorkspace* _tmp9_;
		GalaWindowManager* _tmp10_;
		MetaDisplay* _tmp11_;
		MetaWorkspaceManager* _tmp12_;
		MetaWorkspace* _tmp13_;
#line 461 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		_tmp7_ = window;
#line 461 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		_tmp8_ = meta_window_get_workspace (_tmp7_);
#line 461 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		workspace = _tmp8_;
#line 462 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		_tmp9_ = workspace;
#line 462 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		_tmp10_ = self->priv->_wm;
#line 462 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		_tmp11_ = meta_plugin_get_display ((MetaPlugin*) _tmp10_);
#line 462 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		_tmp12_ = meta_display_get_workspace_manager (_tmp11_);
#line 462 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		_tmp13_ = meta_workspace_manager_get_active_workspace (_tmp12_);
#line 462 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		if (_tmp9_ != _tmp13_) {
#line 1758 "WindowSwitcher.c"
			MetaWorkspace* _tmp14_;
			MetaWindow* _tmp15_;
#line 463 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
			_tmp14_ = workspace;
#line 463 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
			_tmp15_ = window;
#line 463 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
			meta_workspace_activate_with_focus (_tmp14_, _tmp15_, time);
#line 1767 "WindowSwitcher.c"
		} else {
			MetaWindow* _tmp16_;
#line 465 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
			_tmp16_ = window;
#line 465 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
			meta_window_activate (_tmp16_, time);
#line 1774 "WindowSwitcher.c"
		}
	}
#line 469 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	gala_window_switcher_toggle_display (self, FALSE);
#line 450 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_g_object_unref0 (window);
#line 1781 "WindowSwitcher.c"
}

static void
gala_window_switcher_next_window (GalaWindowSwitcher* self,
                                  gboolean backward)
{
	ClutterActor* actor = NULL;
	gboolean _tmp0_ = FALSE;
	ClutterActor* _tmp1_;
	GalaWindowSwitcherIcon* _tmp6_;
	GalaWindowSwitcherIcon* _tmp7_;
	ClutterActor* _tmp27_;
#line 472 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	g_return_if_fail (self != NULL);
#line 475 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp1_ = self->priv->container;
#line 475 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	if (clutter_actor_get_n_children (_tmp1_) == 1) {
#line 1800 "WindowSwitcher.c"
		GalaWindowSwitcherIcon* _tmp2_;
		GalaWindowSwitcherIcon* _tmp3_;
#line 475 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		_tmp2_ = gala_window_switcher_get_current_icon (self);
#line 475 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		_tmp3_ = _tmp2_;
#line 475 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		_tmp0_ = _tmp3_ != NULL;
#line 1809 "WindowSwitcher.c"
	} else {
#line 475 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		_tmp0_ = FALSE;
#line 1813 "WindowSwitcher.c"
	}
#line 475 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	if (_tmp0_) {
#line 1817 "WindowSwitcher.c"
		ClutterBackend* _tmp4_;
		ClutterSeat* _tmp5_;
#line 476 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		_tmp4_ = clutter_get_default_backend ();
#line 476 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		_tmp5_ = clutter_backend_get_default_seat (_tmp4_);
#line 476 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		clutter_seat_bell_notify (_tmp5_);
#line 477 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		_g_object_unref0 (actor);
#line 477 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		return;
#line 1830 "WindowSwitcher.c"
	}
#line 480 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp6_ = gala_window_switcher_get_current_icon (self);
#line 480 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp7_ = _tmp6_;
#line 480 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	if (_tmp7_ == NULL) {
#line 1838 "WindowSwitcher.c"
		ClutterActor* _tmp8_;
		ClutterActor* _tmp9_;
		ClutterActor* _tmp10_;
#line 481 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		_tmp8_ = self->priv->container;
#line 481 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		_tmp9_ = clutter_actor_get_first_child (_tmp8_);
#line 481 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		_tmp10_ = _g_object_ref0 (_tmp9_);
#line 481 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		_g_object_unref0 (actor);
#line 481 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		actor = _tmp10_;
#line 1852 "WindowSwitcher.c"
	} else {
#line 482 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		if (!backward) {
#line 1856 "WindowSwitcher.c"
			GalaWindowSwitcherIcon* _tmp11_;
			GalaWindowSwitcherIcon* _tmp12_;
			ClutterActor* _tmp13_;
			ClutterActor* _tmp14_;
			ClutterActor* _tmp15_;
#line 483 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
			_tmp11_ = gala_window_switcher_get_current_icon (self);
#line 483 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
			_tmp12_ = _tmp11_;
#line 483 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
			_tmp13_ = clutter_actor_get_next_sibling ((ClutterActor*) _tmp12_);
#line 483 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
			_tmp14_ = _g_object_ref0 (_tmp13_);
#line 483 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
			_g_object_unref0 (actor);
#line 483 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
			actor = _tmp14_;
#line 484 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
			_tmp15_ = actor;
#line 484 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
			if (_tmp15_ == NULL) {
#line 1878 "WindowSwitcher.c"
				ClutterActor* _tmp16_;
				ClutterActor* _tmp17_;
				ClutterActor* _tmp18_;
#line 485 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
				_tmp16_ = self->priv->container;
#line 485 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
				_tmp17_ = clutter_actor_get_first_child (_tmp16_);
#line 485 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
				_tmp18_ = _g_object_ref0 (_tmp17_);
#line 485 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
				_g_object_unref0 (actor);
#line 485 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
				actor = _tmp18_;
#line 1892 "WindowSwitcher.c"
			}
		} else {
			GalaWindowSwitcherIcon* _tmp19_;
			GalaWindowSwitcherIcon* _tmp20_;
			ClutterActor* _tmp21_;
			ClutterActor* _tmp22_;
			ClutterActor* _tmp23_;
#line 488 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
			_tmp19_ = gala_window_switcher_get_current_icon (self);
#line 488 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
			_tmp20_ = _tmp19_;
#line 488 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
			_tmp21_ = clutter_actor_get_previous_sibling ((ClutterActor*) _tmp20_);
#line 488 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
			_tmp22_ = _g_object_ref0 (_tmp21_);
#line 488 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
			_g_object_unref0 (actor);
#line 488 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
			actor = _tmp22_;
#line 489 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
			_tmp23_ = actor;
#line 489 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
			if (_tmp23_ == NULL) {
#line 1916 "WindowSwitcher.c"
				ClutterActor* _tmp24_;
				ClutterActor* _tmp25_;
				ClutterActor* _tmp26_;
#line 490 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
				_tmp24_ = self->priv->container;
#line 490 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
				_tmp25_ = clutter_actor_get_last_child (_tmp24_);
#line 490 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
				_tmp26_ = _g_object_ref0 (_tmp25_);
#line 490 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
				_g_object_unref0 (actor);
#line 490 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
				actor = _tmp26_;
#line 1930 "WindowSwitcher.c"
			}
		}
	}
#line 494 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp27_ = actor;
#line 494 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	gala_window_switcher_set_current_icon (self, G_TYPE_CHECK_INSTANCE_CAST (_tmp27_, GALA_TYPE_WINDOW_SWITCHER_ICON, GalaWindowSwitcherIcon));
#line 472 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_g_object_unref0 (actor);
#line 1940 "WindowSwitcher.c"
}

static void
gala_window_switcher_update_caption_text (GalaWindowSwitcher* self)
{
	MetaWindow* _tmp0_ = NULL;
	GalaWindowSwitcherIcon* _tmp1_;
	GalaWindowSwitcherIcon* _tmp2_;
	MetaWindow* current_window = NULL;
	MetaWindow* _tmp7_;
	const gchar* _tmp8_ = NULL;
	MetaWindow* _tmp9_;
	gchar* current_caption = NULL;
	gchar* _tmp13_;
	ClutterText* _tmp14_;
#line 497 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	g_return_if_fail (self != NULL);
#line 498 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp1_ = gala_window_switcher_get_current_icon (self);
#line 498 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp2_ = _tmp1_;
#line 498 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	if (_tmp2_ != NULL) {
#line 1964 "WindowSwitcher.c"
		GalaWindowSwitcherIcon* _tmp3_;
		GalaWindowSwitcherIcon* _tmp4_;
		MetaWindow* _tmp5_;
		MetaWindow* _tmp6_;
#line 498 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		_tmp3_ = gala_window_switcher_get_current_icon (self);
#line 498 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		_tmp4_ = _tmp3_;
#line 498 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		_tmp5_ = gala_window_switcher_icon_get_window (_tmp4_);
#line 498 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		_tmp6_ = _tmp5_;
#line 498 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		_tmp0_ = _tmp6_;
#line 1979 "WindowSwitcher.c"
	} else {
#line 498 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		_tmp0_ = NULL;
#line 1983 "WindowSwitcher.c"
	}
#line 498 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp7_ = _g_object_ref0 (_tmp0_);
#line 498 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	current_window = _tmp7_;
#line 499 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp9_ = current_window;
#line 499 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	if (_tmp9_ != NULL) {
#line 1993 "WindowSwitcher.c"
		MetaWindow* _tmp10_;
		const gchar* _tmp11_;
		const gchar* _tmp12_;
#line 499 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		_tmp10_ = current_window;
#line 499 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		_tmp11_ = meta_window_get_title (_tmp10_);
#line 499 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		_tmp12_ = _tmp11_;
#line 499 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		_tmp8_ = _tmp12_;
#line 2005 "WindowSwitcher.c"
	} else {
#line 499 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		_tmp8_ = "n/a";
#line 2009 "WindowSwitcher.c"
	}
#line 499 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp13_ = g_strdup (_tmp8_);
#line 499 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	current_caption = _tmp13_;
#line 500 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp14_ = self->priv->caption;
#line 500 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	clutter_text_set_text (_tmp14_, current_caption);
#line 497 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_g_free0 (current_caption);
#line 497 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_g_object_unref0 (current_window);
#line 2023 "WindowSwitcher.c"
}

static void
gala_window_switcher_real_key_focus_out (ClutterActor* base)
{
	GalaWindowSwitcher * self;
#line 503 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	self = (GalaWindowSwitcher*) base;
#line 504 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	if (!self->priv->handling_gesture) {
#line 2034 "WindowSwitcher.c"
		GalaWindowManager* _tmp0_;
		MetaDisplay* _tmp1_;
#line 505 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		_tmp0_ = self->priv->_wm;
#line 505 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		_tmp1_ = meta_plugin_get_display ((MetaPlugin*) _tmp0_);
#line 505 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		gala_window_switcher_close_switcher (self, meta_display_get_current_time (_tmp1_), FALSE);
#line 2043 "WindowSwitcher.c"
	}
}

static gboolean
gala_window_switcher_container_mouse_release (GalaWindowSwitcher* self,
                                              ClutterEvent* event)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	gboolean _tmp2_;
	gboolean result;
#line 510 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 510 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	g_return_val_if_fail (event != NULL, FALSE);
#line 514 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp2_ = self->priv->_opened;
#line 514 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	if (_tmp2_) {
#line 514 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		_tmp1_ = clutter_event_get_button (event) == CLUTTER_BUTTON_PRIMARY;
#line 2065 "WindowSwitcher.c"
	} else {
#line 514 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		_tmp1_ = FALSE;
#line 2069 "WindowSwitcher.c"
	}
#line 514 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	if (_tmp1_) {
#line 514 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		_tmp0_ = !self->priv->handling_gesture;
#line 2075 "WindowSwitcher.c"
	} else {
#line 514 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		_tmp0_ = FALSE;
#line 2079 "WindowSwitcher.c"
	}
#line 514 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	if (_tmp0_) {
#line 515 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		gala_window_switcher_close_switcher (self, clutter_event_get_time (event), FALSE);
#line 2085 "WindowSwitcher.c"
	}
#line 518 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	result = TRUE;
#line 518 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	return result;
#line 2091 "WindowSwitcher.c"
}

static gboolean
gala_window_switcher_real_key_release_event (ClutterActor* base,
                                             ClutterEvent* event)
{
	GalaWindowSwitcher * self;
	gboolean _tmp0_ = FALSE;
	gboolean result;
#line 522 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	self = (GalaWindowSwitcher*) base;
#line 522 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	g_return_val_if_fail (event != NULL, FALSE);
#line 526 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	if ((gala_window_switcher_get_current_modifiers (self) & self->priv->modifier_mask) == 0) {
#line 526 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		_tmp0_ = !self->priv->handling_gesture;
#line 2109 "WindowSwitcher.c"
	} else {
#line 526 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		_tmp0_ = FALSE;
#line 2113 "WindowSwitcher.c"
	}
#line 526 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	if (_tmp0_) {
#line 527 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		gala_window_switcher_close_switcher (self, clutter_event_get_time (event), FALSE);
#line 2119 "WindowSwitcher.c"
	}
#line 530 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	result = CLUTTER_EVENT_PROPAGATE;
#line 530 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	return result;
#line 2125 "WindowSwitcher.c"
}

static gboolean
gala_window_switcher_real_key_press_event (ClutterActor* base,
                                           ClutterEvent* event)
{
	GalaWindowSwitcher * self;
	gboolean result;
#line 534 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	self = (GalaWindowSwitcher*) base;
#line 534 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	g_return_val_if_fail (event != NULL, FALSE);
#line 538 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	switch (clutter_event_get_key_symbol (event)) {
#line 538 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		case CLUTTER_KEY_Right:
#line 2142 "WindowSwitcher.c"
		{
#line 540 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
			if (!self->priv->handling_gesture) {
#line 541 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
				gala_window_switcher_next_window (self, FALSE);
#line 2148 "WindowSwitcher.c"
			}
#line 543 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
			result = CLUTTER_EVENT_STOP;
#line 543 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
			return result;
#line 2154 "WindowSwitcher.c"
		}
#line 538 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		case CLUTTER_KEY_Left:
#line 2158 "WindowSwitcher.c"
		{
#line 545 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
			if (!self->priv->handling_gesture) {
#line 546 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
				gala_window_switcher_next_window (self, TRUE);
#line 2164 "WindowSwitcher.c"
			}
#line 548 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
			result = CLUTTER_EVENT_STOP;
#line 548 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
			return result;
#line 2170 "WindowSwitcher.c"
		}
#line 538 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		case CLUTTER_KEY_Escape:
#line 2174 "WindowSwitcher.c"
		{
#line 550 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
			gala_window_switcher_close_switcher (self, clutter_event_get_time (event), TRUE);
#line 551 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
			result = CLUTTER_EVENT_PROPAGATE;
#line 551 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
			return result;
#line 2182 "WindowSwitcher.c"
		}
#line 538 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		case CLUTTER_KEY_Return:
#line 2186 "WindowSwitcher.c"
		{
#line 553 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
			gala_window_switcher_close_switcher (self, clutter_event_get_time (event), FALSE);
#line 554 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
			result = CLUTTER_EVENT_PROPAGATE;
#line 554 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
			return result;
#line 2194 "WindowSwitcher.c"
		}
		default:
#line 538 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		break;
#line 2199 "WindowSwitcher.c"
	}
#line 557 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	result = CLUTTER_EVENT_PROPAGATE;
#line 557 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	return result;
#line 2205 "WindowSwitcher.c"
}

static inline ClutterModifierType
gala_window_switcher_get_current_modifiers (GalaWindowSwitcher* self)
{
	ClutterModifierType modifiers = 0U;
	GalaWindowManager* _tmp0_;
	MetaDisplay* _tmp1_;
	MetaCursorTracker* _tmp2_;
	ClutterModifierType _tmp3_ = 0U;
	ClutterModifierType result;
#line 561 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	g_return_val_if_fail (self != NULL, 0U);
#line 563 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp0_ = self->priv->_wm;
#line 563 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp1_ = meta_plugin_get_display ((MetaPlugin*) _tmp0_);
#line 563 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp2_ = meta_cursor_tracker_get_for_display (_tmp1_);
#line 563 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	meta_cursor_tracker_get_pointer (_tmp2_, NULL, &_tmp3_);
#line 563 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	modifiers = _tmp3_;
#line 565 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	result = modifiers & CLUTTER_MODIFIER_MASK;
#line 565 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	return result;
#line 2233 "WindowSwitcher.c"
}

GalaWindowManager*
gala_window_switcher_get_wm (GalaWindowSwitcher* self)
{
	GalaWindowManager* result;
	GalaWindowManager* _tmp0_;
#line 20 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 20 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp0_ = self->priv->_wm;
#line 20 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	result = _tmp0_;
#line 20 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	return result;
#line 2249 "WindowSwitcher.c"
}

static void
gala_window_switcher_set_wm (GalaWindowSwitcher* self,
                             GalaWindowManager* value)
{
	GalaWindowManager* old_value;
#line 20 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	g_return_if_fail (self != NULL);
#line 20 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	old_value = gala_window_switcher_get_wm (self);
#line 20 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	if (old_value != value) {
#line 2263 "WindowSwitcher.c"
		GalaWindowManager* _tmp0_;
#line 20 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 20 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		_g_object_unref0 (self->priv->_wm);
#line 20 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		self->priv->_wm = _tmp0_;
#line 20 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		g_object_notify_by_pspec ((GObject *) self, gala_window_switcher_properties[GALA_WINDOW_SWITCHER_WM_PROPERTY]);
#line 2273 "WindowSwitcher.c"
	}
}

GalaGestureTracker*
gala_window_switcher_get_gesture_tracker (GalaWindowSwitcher* self)
{
	GalaGestureTracker* result;
	GalaGestureTracker* _tmp0_;
#line 21 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 21 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp0_ = self->priv->_gesture_tracker;
#line 21 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	result = _tmp0_;
#line 21 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	return result;
#line 2290 "WindowSwitcher.c"
}

static void
gala_window_switcher_set_gesture_tracker (GalaWindowSwitcher* self,
                                          GalaGestureTracker* value)
{
	GalaGestureTracker* old_value;
#line 21 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	g_return_if_fail (self != NULL);
#line 21 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	old_value = gala_window_switcher_get_gesture_tracker (self);
#line 21 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	if (old_value != value) {
#line 2304 "WindowSwitcher.c"
		GalaGestureTracker* _tmp0_;
#line 21 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 21 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		_g_object_unref0 (self->priv->_gesture_tracker);
#line 21 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		self->priv->_gesture_tracker = _tmp0_;
#line 21 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		g_object_notify_by_pspec ((GObject *) self, gala_window_switcher_properties[GALA_WINDOW_SWITCHER_GESTURE_TRACKER_PROPERTY]);
#line 2314 "WindowSwitcher.c"
	}
}

gboolean
gala_window_switcher_get_opened (GalaWindowSwitcher* self)
{
	gboolean result;
#line 22 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 22 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	result = self->priv->_opened;
#line 22 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	return result;
#line 2328 "WindowSwitcher.c"
}

static void
gala_window_switcher_set_opened (GalaWindowSwitcher* self,
                                 gboolean value)
{
	gboolean old_value;
#line 22 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	g_return_if_fail (self != NULL);
#line 22 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	old_value = gala_window_switcher_get_opened (self);
#line 22 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	if (old_value != value) {
#line 22 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		self->priv->_opened = value;
#line 22 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		g_object_notify_by_pspec ((GObject *) self, gala_window_switcher_properties[GALA_WINDOW_SWITCHER_OPENED_PROPERTY]);
#line 2346 "WindowSwitcher.c"
	}
}

static GalaWindowSwitcherIcon*
gala_window_switcher_get_current_icon (GalaWindowSwitcher* self)
{
	GalaWindowSwitcherIcon* result;
	GalaWindowSwitcherIcon* _tmp0_;
#line 34 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 35 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp0_ = self->priv->_current_icon;
#line 35 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	result = _tmp0_;
#line 35 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	return result;
#line 2363 "WindowSwitcher.c"
}

static void
gala_window_switcher_set_current_icon (GalaWindowSwitcher* self,
                                       GalaWindowSwitcherIcon* value)
{
	GalaWindowSwitcherIcon* _tmp0_;
	GalaWindowSwitcherIcon* _tmp2_;
	GalaWindowSwitcherIcon* _tmp3_;
#line 37 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	g_return_if_fail (self != NULL);
#line 38 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp0_ = self->priv->_current_icon;
#line 38 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	if (_tmp0_ != NULL) {
#line 2379 "WindowSwitcher.c"
		GalaWindowSwitcherIcon* _tmp1_;
#line 39 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		_tmp1_ = self->priv->_current_icon;
#line 39 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		gala_window_switcher_icon_set_selected (_tmp1_, FALSE);
#line 2385 "WindowSwitcher.c"
	}
#line 42 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp2_ = _g_object_ref0 (value);
#line 42 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_g_object_unref0 (self->priv->_current_icon);
#line 42 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	self->priv->_current_icon = _tmp2_;
#line 43 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp3_ = self->priv->_current_icon;
#line 43 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	if (_tmp3_ != NULL) {
#line 2397 "WindowSwitcher.c"
		GalaWindowSwitcherIcon* _tmp4_;
		GalaWindowSwitcherIcon* _tmp5_;
#line 44 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		_tmp4_ = self->priv->_current_icon;
#line 44 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		gala_window_switcher_icon_set_selected (_tmp4_, TRUE);
#line 45 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		_tmp5_ = self->priv->_current_icon;
#line 45 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		clutter_actor_grab_key_focus ((ClutterActor*) _tmp5_);
#line 2408 "WindowSwitcher.c"
	}
#line 48 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	gala_window_switcher_update_caption_text (self);
#line 2412 "WindowSwitcher.c"
}

static gboolean
_gala_window_switcher_container_mouse_release_clutter_actor_button_release_event (ClutterActor* _sender,
                                                                                  ClutterEvent* event,
                                                                                  gpointer self)
{
	gboolean result;
	result = gala_window_switcher_container_mouse_release ((GalaWindowSwitcher*) self, event);
#line 100 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	return result;
#line 2424 "WindowSwitcher.c"
}

static void
_clutter_content_invalidate_g_object_notify (GObject* _sender,
                                             GParamSpec* pspec,
                                             gpointer self)
{
#line 103 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	clutter_content_invalidate ((ClutterContent*) self);
#line 2434 "WindowSwitcher.c"
}

static void
_gala_window_switcher_scale_meta_monitor_manager_monitors_changed (MetaMonitorManager* _sender,
                                                                   gpointer self)
{
#line 106 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	gala_window_switcher_scale ((GalaWindowSwitcher*) self);
#line 2443 "WindowSwitcher.c"
}

static void
_gala_window_switcher___lambda83_ (GalaWindowSwitcher* self)
{
	guint _tmp0_;
	guint _tmp1_;
#line 108 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp0_ = clutter_actor_get_opacity ((ClutterActor*) self);
#line 108 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp1_ = _tmp0_;
#line 108 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	g_object_set ((ClutterActor*) self, "visible", _tmp1_ != ((guint) 0), NULL);
#line 2457 "WindowSwitcher.c"
}

static void
__gala_window_switcher___lambda83__g_object_notify (GObject* _sender,
                                                    GParamSpec* pspec,
                                                    gpointer self)
{
#line 108 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_gala_window_switcher___lambda83_ ((GalaWindowSwitcher*) self);
#line 2467 "WindowSwitcher.c"
}

static GObject *
gala_window_switcher_constructor (GType type,
                                  guint n_construct_properties,
                                  GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	GalaWindowSwitcher * self;
	GalaDrawingStyleManager* _tmp0_;
	ClutterFlowLayout* _tmp1_;
	ClutterActor* _tmp2_ = NULL;
	AtkObject* _tmp3_;
	ClutterActor* _tmp4_;
	AtkObject* _tmp5_;
	gchar* _tmp6_;
	ClutterText* _tmp7_ = NULL;
	ClutterActor* _tmp8_;
	ClutterText* _tmp9_;
	ClutterBoxLayout* _tmp10_ = NULL;
	ClutterBoxLayout* _tmp11_;
	GalaShadowEffect* _tmp12_ = NULL;
	GalaShadowEffect* _tmp13_;
	ClutterActor* _tmp14_;
	GalaDrawingStyleManager* _tmp15_;
	ClutterContent* _tmp16_;
	ClutterContent* _tmp17_;
	MetaMonitorManager* monitor_manager = NULL;
	GalaWindowManager* _tmp18_;
	MetaDisplay* _tmp19_;
	MetaContext* _tmp20_;
	MetaBackend* _tmp21_;
	MetaMonitorManager* _tmp22_;
	MetaMonitorManager* _tmp23_;
#line 61 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	parent_class = G_OBJECT_CLASS (gala_window_switcher_parent_class);
#line 61 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 61 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, GALA_TYPE_WINDOW_SWITCHER, GalaWindowSwitcher);
#line 62 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp0_ = gala_drawing_style_manager_get_instance ();
#line 62 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_g_object_unref0 (self->priv->style_manager);
#line 62 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	self->priv->style_manager = _tmp0_;
#line 64 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp1_ = (ClutterFlowLayout*) clutter_flow_layout_new (CLUTTER_ORIENTATION_HORIZONTAL);
#line 64 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	g_object_ref_sink (_tmp1_);
#line 64 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp2_ = clutter_actor_new ();
#line 64 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	clutter_actor_set_reactive (_tmp2_, TRUE);
#line 64 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	clutter_actor_set_layout_manager (_tmp2_, (ClutterLayoutManager*) _tmp1_);
#line 64 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_g_object_unref0 (_tmp1_);
#line 64 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	g_object_ref_sink (_tmp2_);
#line 64 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_g_object_unref0 (self->priv->container);
#line 64 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	self->priv->container = _tmp2_;
#line 73 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp3_ = clutter_actor_get_accessible ((ClutterActor*) self);
#line 73 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	g_object_set (_tmp3_, "accessible-name", _ ("Window switcher"), NULL);
#line 74 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp4_ = self->priv->container;
#line 74 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp5_ = clutter_actor_get_accessible (_tmp4_);
#line 74 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	g_object_set (_tmp5_, "accessible-role", ATK_ROLE_LIST, NULL);
#line 76 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp6_ = g_strdup (GALA_WINDOW_SWITCHER_CAPTION_FONT_NAME);
#line 76 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp7_ = (ClutterText*) clutter_text_new ();
#line 76 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	clutter_text_set_font_name (_tmp7_, _tmp6_);
#line 76 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_g_free0 (_tmp6_);
#line 76 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	clutter_text_set_ellipsize (_tmp7_, PANGO_ELLIPSIZE_END);
#line 76 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	clutter_text_set_line_alignment (_tmp7_, PANGO_ALIGN_CENTER);
#line 76 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	g_object_ref_sink (_tmp7_);
#line 76 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_g_object_unref0 (self->priv->caption);
#line 76 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	self->priv->caption = _tmp7_;
#line 82 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp8_ = self->priv->container;
#line 82 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	clutter_actor_add_child ((ClutterActor*) self, _tmp8_);
#line 83 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp9_ = self->priv->caption;
#line 83 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	clutter_actor_add_child ((ClutterActor*) self, (ClutterActor*) _tmp9_);
#line 85 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	clutter_actor_set_reactive ((ClutterActor*) self, TRUE);
#line 86 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	g_object_set ((ClutterActor*) self, "visible", FALSE, NULL);
#line 87 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	clutter_actor_set_opacity ((ClutterActor*) self, (guint) 0);
#line 88 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp10_ = (ClutterBoxLayout*) clutter_box_layout_new ();
#line 88 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	clutter_box_layout_set_orientation (_tmp10_, CLUTTER_ORIENTATION_VERTICAL);
#line 88 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	g_object_ref_sink (_tmp10_);
#line 88 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp11_ = _tmp10_;
#line 88 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	clutter_actor_set_layout_manager ((ClutterActor*) self, (ClutterLayoutManager*) _tmp11_);
#line 88 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_g_object_unref0 (_tmp11_);
#line 92 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp12_ = gala_shadow_effect_new ("window-switcher");
#line 92 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	gala_shadow_effect_set_border_radius (_tmp12_, gala_internal_utils_scale_to_int (9, self->priv->scaling_factor));
#line 92 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	gala_shadow_effect_set_shadow_opacity (_tmp12_, (guint8) 100);
#line 92 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	g_object_ref_sink (_tmp12_);
#line 92 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_g_object_unref0 (self->priv->shadow_effect);
#line 92 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	self->priv->shadow_effect = _tmp12_;
#line 96 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp13_ = self->priv->shadow_effect;
#line 96 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	clutter_actor_add_effect ((ClutterActor*) self, (ClutterEffect*) _tmp13_);
#line 98 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	gala_window_switcher_scale (self);
#line 100 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp14_ = self->priv->container;
#line 100 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	g_signal_connect_object (_tmp14_, "button-release-event", (GCallback) _gala_window_switcher_container_mouse_release_clutter_actor_button_release_event, self, 0);
#line 103 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp15_ = self->priv->style_manager;
#line 103 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp16_ = clutter_actor_get_content ((ClutterActor*) self);
#line 103 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp17_ = _tmp16_;
#line 103 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	g_signal_connect_object ((GObject*) _tmp15_, "notify::prefers-color-scheme", (GCallback) _clutter_content_invalidate_g_object_notify, _tmp17_, 0);
#line 105 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp18_ = self->priv->_wm;
#line 105 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp19_ = meta_plugin_get_display ((MetaPlugin*) _tmp18_);
#line 105 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp20_ = meta_display_get_context (_tmp19_);
#line 105 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp21_ = meta_context_get_backend (_tmp20_);
#line 105 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp22_ = meta_backend_get_monitor_manager (_tmp21_);
#line 105 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	monitor_manager = _tmp22_;
#line 106 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp23_ = monitor_manager;
#line 106 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	g_signal_connect_object (_tmp23_, "monitors-changed", (GCallback) _gala_window_switcher_scale_meta_monitor_manager_monitors_changed, self, 0);
#line 108 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	g_signal_connect_object ((GObject*) self, "notify::opacity", (GCallback) __gala_window_switcher___lambda83__g_object_notify, self, 0);
#line 61 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	return obj;
#line 2637 "WindowSwitcher.c"
}

static void
gala_window_switcher_class_init (GalaWindowSwitcherClass * klass,
                                 gpointer klass_data)
{
#line 10 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	gala_window_switcher_parent_class = g_type_class_peek_parent (klass);
#line 10 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	g_type_class_adjust_private_offset (klass, &GalaWindowSwitcher_private_offset);
#line 10 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	((ClutterActorClass *) klass)->get_preferred_width = (void (*) (ClutterActor*, gfloat, gfloat*, gfloat*)) gala_window_switcher_real_get_preferred_width;
#line 10 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	((GalaCanvasActorClass *) klass)->draw = (void (*) (GalaCanvasActor*, cairo_t*, gint, gint)) gala_window_switcher_real_draw;
#line 10 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	((ClutterActorClass *) klass)->key_focus_out = (void (*) (ClutterActor*)) gala_window_switcher_real_key_focus_out;
#line 10 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	((ClutterActorClass *) klass)->key_release_event = (gboolean (*) (ClutterActor*, ClutterEvent*)) gala_window_switcher_real_key_release_event;
#line 10 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	((ClutterActorClass *) klass)->key_press_event = (gboolean (*) (ClutterActor*, ClutterEvent*)) gala_window_switcher_real_key_press_event;
#line 10 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_gala_window_switcher_get_property;
#line 10 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_gala_window_switcher_set_property;
#line 10 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	G_OBJECT_CLASS (klass)->constructor = gala_window_switcher_constructor;
#line 10 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	G_OBJECT_CLASS (klass)->finalize = gala_window_switcher_finalize;
#line 10 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GALA_WINDOW_SWITCHER_WM_PROPERTY, gala_window_switcher_properties[GALA_WINDOW_SWITCHER_WM_PROPERTY] = g_param_spec_object ("wm", "wm", "wm", GALA_TYPE_WINDOW_MANAGER, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
#line 10 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GALA_WINDOW_SWITCHER_GESTURE_TRACKER_PROPERTY, gala_window_switcher_properties[GALA_WINDOW_SWITCHER_GESTURE_TRACKER_PROPERTY] = g_param_spec_object ("gesture-tracker", "gesture-tracker", "gesture-tracker", GALA_TYPE_GESTURE_TRACKER, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
#line 10 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GALA_WINDOW_SWITCHER_OPENED_PROPERTY, gala_window_switcher_properties[GALA_WINDOW_SWITCHER_OPENED_PROPERTY] = g_param_spec_boolean ("opened", "opened", "opened", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 2672 "WindowSwitcher.c"
}

static void
gala_window_switcher_instance_init (GalaWindowSwitcher * self,
                                    gpointer klass)
{
#line 10 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	self->priv = gala_window_switcher_get_instance_private (self);
#line 22 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	self->priv->_opened = FALSE;
#line 24 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	self->priv->handling_gesture = FALSE;
#line 26 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	self->priv->modal_proxy = NULL;
#line 32 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	self->priv->_current_icon = NULL;
#line 52 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	self->priv->scaling_factor = 1.0f;
#line 2691 "WindowSwitcher.c"
}

static void
gala_window_switcher_finalize (GObject * obj)
{
	GalaWindowSwitcher * self;
#line 10 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, GALA_TYPE_WINDOW_SWITCHER, GalaWindowSwitcher);
#line 20 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_g_object_unref0 (self->priv->_wm);
#line 21 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_g_object_unref0 (self->priv->_gesture_tracker);
#line 26 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_g_object_unref0 (self->priv->modal_proxy);
#line 27 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_g_object_unref0 (self->priv->style_manager);
#line 28 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_g_object_unref0 (self->priv->container);
#line 29 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_g_object_unref0 (self->priv->caption);
#line 30 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_g_object_unref0 (self->priv->shadow_effect);
#line 32 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_g_object_unref0 (self->priv->_current_icon);
#line 10 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	G_OBJECT_CLASS (gala_window_switcher_parent_class)->finalize (obj);
#line 2718 "WindowSwitcher.c"
}

 G_GNUC_NO_INLINE static GType
gala_window_switcher_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (GalaWindowSwitcherClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) gala_window_switcher_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (GalaWindowSwitcher), 0, (GInstanceInitFunc) gala_window_switcher_instance_init, NULL };
	GType gala_window_switcher_type_id;
	gala_window_switcher_type_id = g_type_register_static (GALA_TYPE_CANVAS_ACTOR, "GalaWindowSwitcher", &g_define_type_info, 0);
	GalaWindowSwitcher_private_offset = g_type_add_instance_private (gala_window_switcher_type_id, sizeof (GalaWindowSwitcherPrivate));
	return gala_window_switcher_type_id;
}

GType
gala_window_switcher_get_type (void)
{
	static gsize gala_window_switcher_type_id__once = 0;
	if (g_once_init_enter (&gala_window_switcher_type_id__once)) {
		GType gala_window_switcher_type_id;
		gala_window_switcher_type_id = gala_window_switcher_get_type_once ();
		g_once_init_leave (&gala_window_switcher_type_id__once, gala_window_switcher_type_id);
	}
	return gala_window_switcher_type_id__once;
}

static void
_vala_gala_window_switcher_get_property (GObject * object,
                                         guint property_id,
                                         GValue * value,
                                         GParamSpec * pspec)
{
	GalaWindowSwitcher * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, GALA_TYPE_WINDOW_SWITCHER, GalaWindowSwitcher);
#line 10 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	switch (property_id) {
#line 10 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		case GALA_WINDOW_SWITCHER_WM_PROPERTY:
#line 10 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		g_value_set_object (value, gala_window_switcher_get_wm (self));
#line 10 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		break;
#line 10 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		case GALA_WINDOW_SWITCHER_GESTURE_TRACKER_PROPERTY:
#line 10 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		g_value_set_object (value, gala_window_switcher_get_gesture_tracker (self));
#line 10 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		break;
#line 10 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		case GALA_WINDOW_SWITCHER_OPENED_PROPERTY:
#line 10 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		g_value_set_boolean (value, gala_window_switcher_get_opened (self));
#line 10 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		break;
#line 2771 "WindowSwitcher.c"
		default:
#line 10 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 10 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		break;
#line 2777 "WindowSwitcher.c"
	}
}

static void
_vala_gala_window_switcher_set_property (GObject * object,
                                         guint property_id,
                                         const GValue * value,
                                         GParamSpec * pspec)
{
	GalaWindowSwitcher * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, GALA_TYPE_WINDOW_SWITCHER, GalaWindowSwitcher);
#line 10 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	switch (property_id) {
#line 10 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		case GALA_WINDOW_SWITCHER_WM_PROPERTY:
#line 10 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		gala_window_switcher_set_wm (self, g_value_get_object (value));
#line 10 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		break;
#line 10 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		case GALA_WINDOW_SWITCHER_GESTURE_TRACKER_PROPERTY:
#line 10 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		gala_window_switcher_set_gesture_tracker (self, g_value_get_object (value));
#line 10 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		break;
#line 10 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		case GALA_WINDOW_SWITCHER_OPENED_PROPERTY:
#line 10 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		gala_window_switcher_set_opened (self, g_value_get_boolean (value));
#line 10 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		break;
#line 2809 "WindowSwitcher.c"
		default:
#line 10 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 10 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		break;
#line 2815 "WindowSwitcher.c"
	}
}

